#if !defined(AFX_MMConversionDlg_H__34F834C1_D7EF_47CD_AA9B_BAAB72996FC5__INCLUDED_)
#define AFX_MMConversionDlg_H__34F834C1_D7EF_47CD_AA9B_BAAB72996FC5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// MMConversionDlg.h : header file
//

#include "Image.h"
#include "MemDC.h"
#include "colorbox.h"
#include <vector>

/////////////////////////////////////////////////////////////////////////////
// MMConversionColorBox subclass

class MMConversionColorBox : public CColorBox
{
//Construction
public:
  MMConversionColorBox(class MMConversionDlg* m) : m_mm_dlg(m) {}

protected:
//{{AFX_MSG(MMConversionColorBox)
afx_msg BOOL OnClickedEx();
//}}AFX_MSG

DECLARE_MESSAGE_MAP()

private:
  class MMConversionDlg* m_mm_dlg;
};

/////////////////////////////////////////////////////////////////////////////
// MMConversionDlg dialog

class MMConversionDlg : public CDialog
{
// Construction
public:
	MMConversionDlg(CWnd* pParent = NULL);   // standard constructor
  const float GetConversion(void) const {return m_pixels_per_mm;}
  void SetLineColor(COLORREF color);
  void SetConversion(float conversion);
  //For redrawing after a new color has been selected
  void Redraw();

  // Dialog Data

	//{{AFX_DATA(MMConversionDlg)
	enum { IDD = IDD_CONVERSION };
	CButton	m_button_delete_all;
	CButton	m_button_delete_last;
	MMConversionColorBox m_root_color;
	CButton	m_picture_button;
	CButton m_radio_image;
  CButton m_radio_100;
  CButton m_radio_12point5;
  CButton m_radio_50;
  CButton m_radio_25;
	CStatic	m_text;
	CStatic	m_image;
	CStatic	m_static_pixels;
	CEdit	m_edit_conversion;
	CEdit	m_edit_milli;
	CStatic	m_line_color_label;
	CStatic	m_static_mm_label;
	CStatic	m_static_pixels_label;
	//}}AFX_DATA

  // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MMConversionDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(MMConversionDlg)
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnKillfocusEditMilli();
	virtual void OnOK();
	afx_msg void OnPicture();
	afx_msg void OnRadioImage();
	afx_msg void OnRadioManual();
	afx_msg void OnKillfocusEditConversion();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDeleteLast();
	afx_msg void OnDeleteAllLines();
	afx_msg void OnRadio100();
	afx_msg void OnRadio75();
	afx_msg void OnRadio50();
	afx_msg void OnRadio25();
	afx_msg void OnRADIO12point5();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
    
private:
  // varibles
  HCURSOR m_cur_pen;
  blepo::ImgBgr m_img;
  float m_pixels_per_mm;
  int m_scale;
  CPoint m_point1, m_point2;
  std::vector<CPoint> m_line_points;
  std::vector<float> m_pixel_distances;
  float m_avg_pixels;
  bool m_waiting_for_second;
  int m_mode;
  CString fname;

  // functions
  void Redraw(CDC& dc);
  void GrayImageArea();
  void Recalculate();
  float CalculateAvgPixels(std::vector<float> pixel_lengths, int number_of_lines);
  
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MMConversionDlg_H__34F834C1_D7EF_47CD_AA9B_BAAB72996FC5__INCLUDED_)
