
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the ROOTDETECT_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// ROOTDETECT_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef ROOTDETECT_EXPORTS
#define ROOTDETECT_API __declspec(dllexport)
#else
#define ROOTDETECT_API __declspec(dllimport)
#endif

// This class is exported from the RootDetect.dll
//class ROOTDETECT_API CRootDetect {
//public:
//	CRootDetect(void);
//	// TODO: add your methods here.
//};
//
//extern ROOTDETECT_API int nRootDetect;
//
//ROOTDETECT_API int fnRootDetect(void);

#include <vector>

struct RootPoint 
{ 
  int x;
  int y;
};

struct DetectedRoot
{
  std::vector<RootPoint> points;
  std::vector<RootPoint> extremity;
  double diameter;
};

// Be sure to allocate space for 'output' first.  Will fill in invalid roots and points with -1.
ROOTDETECT_API void MyDetectRoots(int image_width, int image_height, unsigned char* image_bgr_data, std::vector<DetectedRoot>* output);

